#Demo3.ps1
#Mise en place d'un ColoredConsoleAppender en tant qu'appender par dfaut.
#Manipulation des Layout
.\InitializeLG4N.ps1 
[System.Collections.Hashtable[]] $ConfigColors=@(
   @{Level="Warn";FColor="Yellow";BColor=""},
   @{Level="Info";FColor="Cyan";BColor=""},
   @{Level="Debug";FColor="Green";BColor=""},
   @{Level="Error";FColor="Red";BColor=""}
 )
 
$Header="Pied de page"
 #Cre un appender coloris et le transmet dans le pipeline
New-LogColoredConsoleAppender $ConfigColors|`
    #On ajoute un objet Layout  l'appender prcdement cr
    #!!!!!!!!!
    # Le premier paramtre attendu est renseign via le pipeleline,
    # on doit donc prciser le nom du paramtre ( -L ), sinon l'affectation se fait 
    # sur le premier paramtre, ce qui provoquera des erreurs de typage. 
    #!!!!!!!!!
 Add-LogLayout -L "%date %-5level - %message%newline" -F "En-tte de page" -H $Header|`
 Enable-LogAppender|`
   #Configure le framework avec l'appender provenant du pipeline
 Set-LogBasicConfigurator 
 
$Log = Get-LogLogger "LogPowerShell" 
$Log.Info("TestMessage1");

# !!!! On modifie le pattern d'affichage !!!!!!!!

 #Cre un appender coloris, le layout est cre automatiquement si 
 #on renseigne le paramtre $LayoutPattern, les champs footer et header ne sont pas renseign
New-LogColoredConsoleAppender $ConfigColors -L "%date{dd-MM-yyyy } %-5level - %message%newline"|`
 Enable-LogAppender|`
 Set-LogBasicConfigurator

$Log.Info("TestMessage2");

Stop-Log
