#Demo8.ps1
#Test d'une hirarchie de loggers

function Log{
 $LogMain.Info("Message du logger : Main")
 $LogMainA.Debug("Message du logger : Main.A")
 $LogMainAB.Debug("Message du logger : Main.A.B")
}
 #Dclare la hirarchie
$LogMain  = Get-LogLogger "Main"
$LogMainA = Get-LogLogger "Main.A"
$LogMainAB = Get-LogLogger "Main.A.B"
Set-LogBasicConfigurator -default 

 #Tous loggers propagent tous les vnements qu'ils reoivent
Log

 #Seul le logger Main propage les vnements de log
$LogMainA.Logger.Additivity = $false
Log

 #Seul le logger MainAB ne propage pas les vnements reus
$LogMainA.Logger.Additivity = $true
$LogMainAB.Logger.Additivity = $false
Log

Add-LogLoggerAppender -L $LogMain  -A (
    New-LogColoredConsoleAppender $LogDefaultColors -Name "ConsoleColoris"|`
           Add-LogLayout -L "%date %-5level - %message%newline" |`
           Enable-LogAppender
   )           
Log

Get-Loggers|% {$_.Logger.Additivity=$True}
Log

 #Ajoute un appender Eventlog au logger LogMainAB
 #Chaque logger possde un appender ddi
Add-LogLoggerAppender -L $LogMainAB  -A (
    New-LogEventLogAppender -Name "EventLogWindows" -EventLogName "MonScript-PowerShell"|`
           Add-LogLayout -L "%date{dd-MM-yyyy } %-5level [%x] - %message%newline" |`
           Enable-LogAppender
   )           

Log
# Suite dans Demo8-1.ps1
